#------------------------------------------------------------------------------
#    plSokoban Suite - perl OOP sokoban implementation
#    Copyright (c) 2002 Arne Bochem <webmaster@arneb.de>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#------------------------------------------------------------------------------

use strict;
package Sokoban::Element;

sub new
{
	my $class = shift;
	my ($parent, $x, $y, $element_type, $target) = @_;

	return bless({'_parent' => $parent, '_x' => $x, '_y' => $y, '_target' => $target, '_element_type' => $element_type}, $class);
}

sub player
{
	return(0);
}

sub boulder
{
	return(0);
}

sub free
{
	return(0);
}

sub move
{
	return(0);
}

sub redefine
{
	my ($self, $element_type) = @_;

	$self->{'_parent'}->redefine($self, $element_type);
}

sub element_type
{
	my $self = shift;
	return $self->{'_element_type'};
}

1;
