#!/usr/bin/perl
#------------------------------------------------------------------------------
#    plSokoban Suite - perl OOP sokoban implementation
#    Copyright (c) 2002 Arne Bochem <webmaster@arneb.de>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#------------------------------------------------------------------------------

use strict;
use Sokoban::Engine;

my $field =
[['o', ' ', 'o', ' ', 'o'],
 [' ', 'x', 'x', 'x', ' '],
 ['o', 'x', '@', 'x', 'o'],
 [' ', 'x', 'x', 'x', ' '],
 ['o', ' ', 'o', ' ', 'o']];

my %commands = ('w' => 'up', 's' => 'down', 'a' => 'left', 'd' => 'right');

my $sokoban = Sokoban::Engine->new($field);

print $sokoban->ascii_art()."\n";

while (!$sokoban->boulders_done())
{
	my $line = <>;
	chomp($line);
	$sokoban->command($commands{$line});
	print $sokoban->ascii_art()."\n";
}
